"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var faSort_1 = require("@fortawesome/free-solid-svg-icons/faSort");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var every_1 = __importDefault(require("lodash/every"));
var filter_1 = __importDefault(require("lodash/filter"));
var find_1 = __importDefault(require("lodash/find"));
var includes_1 = __importDefault(require("lodash/includes"));
var isArray_1 = __importDefault(require("lodash/isArray"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var isFunction_1 = __importDefault(require("lodash/isFunction"));
var isPlainObject_1 = __importDefault(require("lodash/isPlainObject"));
var map_1 = __importDefault(require("lodash/map"));
var reject_1 = __importDefault(require("lodash/reject"));
var reverse_1 = __importDefault(require("lodash/reverse"));
var some_1 = __importDefault(require("lodash/some"));
var sortBy_1 = __importDefault(require("lodash/sortBy"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var __1 = require("../../");
var theme_1 = __importDefault(require("../../theme"));
var utils_1 = require("../../utils");
var Checkbox_1 = __importDefault(require("../Checkbox"));
var Pager_1 = __importDefault(require("../Pager"));
var TableRow_1 = require("./TableRow");
exports.TableRow = TableRow_1.TableRow;
var highlightStyle = "\n\tbackground-color: " + theme_1.default.colors.info.light + ";\n";
var BaseTableWrapper = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\toverflow-x: auto;\n\tmax-width: 100%;\n"], ["\n\toverflow-x: auto;\n\tmax-width: 100%;\n"])));
var BaseTable = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: table;\n\twidth: 100%;\n\tborder-spacing: 0;\n\tborder-bottom: 1px solid ", ";\n\n\t> [data-display='table-head'] {\n\t\tdisplay: table-header-group;\n\t\tbackground-color: ", ";\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\tborder-bottom: 1px solid ", ";\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 10px 20px;\n\t\t\t\tfont-size: ", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\tpadding-left: ", ";\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\tpadding-right: 40px;\n\t\t\t}\n\t\t}\n\t}\n\n\t> [data-display='table-body'] {\n\t\tdisplay: table-row-group;\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\t\t\ttext-decoration: none;\n\t\t\tcolor: ", ";\n\t\t\tfont-size: ", ";\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 14px 20px;\n\t\t\t\ttext-decoration: none;\n\t\t\t\tcolor: inherit;\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\tpadding-left: ", ";\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\tpadding-right: 40px;\n\t\t\t}\n\n\t\t\t> a[data-display='table-cell'] {\n\t\t\t\tcursor: ", ";\n\t\t\t}\n\n\t\t\t&:nth-of-type(even) {\n\t\t\t\tbackground-color: ", ";\n\t\t\t}\n\n\t\t\t&:hover {\n\t\t\t\ttext-decoration: none;\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t&[data-highlight='true'] {\n\t\t\t\t", " > [data-display=\"table-cell\"]:first-child {\n\t\t\t\t\tbox-shadow: inset 3px 0px 0 ", ";\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n"], ["\n\tdisplay: table;\n\twidth: 100%;\n\tborder-spacing: 0;\n\tborder-bottom: 1px solid ", ";\n\n\t> [data-display='table-head'] {\n\t\tdisplay: table-header-group;\n\t\tbackground-color: ", ";\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\tborder-bottom: 1px solid ", ";\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 10px 20px;\n\t\t\t\tfont-size: ", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\tpadding-left: ", ";\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\tpadding-right: 40px;\n\t\t\t}\n\t\t}\n\t}\n\n\t> [data-display='table-body'] {\n\t\tdisplay: table-row-group;\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\t\t\ttext-decoration: none;\n\t\t\tcolor: ", ";\n\t\t\tfont-size: ", ";\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 14px 20px;\n\t\t\t\ttext-decoration: none;\n\t\t\t\tcolor: inherit;\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\tpadding-left: ", ";\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\tpadding-right: 40px;\n\t\t\t}\n\n\t\t\t> a[data-display='table-cell'] {\n\t\t\t\tcursor: ",
    ";\n\t\t\t}\n\n\t\t\t&:nth-of-type(even) {\n\t\t\t\tbackground-color: ", ";\n\t\t\t}\n\n\t\t\t&:hover {\n\t\t\t\ttext-decoration: none;\n\t\t\t\t",
    ";\n\t\t\t}\n\n\t\t\t&[data-highlight='true'] {\n\t\t\t\t", " > [data-display=\"table-cell\"]:first-child {\n\t\t\t\t\tbox-shadow: inset 3px 0px 0 ", ";\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n"])), function (props) { return props.theme.colors.quartenary.main; }, function (props) { return props.theme.colors.quartenary.light; }, function (props) { return props.theme.colors.quartenary.main; }, function (props) { return utils_1.px(props.theme.fontSizes[1]); }, function (props) { return (props.hasCheckbox ? '20px' : '40px'); }, function (props) { return (props.hasCheckbox ? 'width: 60px' : ''); }, function (props) { return props.theme.colors.secondary.main; }, function (props) { return utils_1.px(props.theme.fontSizes[1]); }, function (props) { return (props.hasCheckbox ? '20px' : '40px'); }, function (props) { return (props.hasCheckbox ? 'width: 60px' : ''); }, function (props) {
    return props.hasRowClick || props.hasGetRowRef ? 'pointer' : 'auto';
}, function (props) { return props.theme.colors.quartenary.light; }, function (props) {
    return props.hasRowClick || props.hasGetRowRef || props.hasCheckbox
        ? highlightStyle
        : '';
}, highlightStyle, function (props) { return props.theme.colors.info.main; });
var HeaderButton = styled_components_1.default(__1.Button)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tdisplay: block;\n"], ["\n\tdisplay: block;\n"])));
var Table = (function (_super) {
    __extends(Table, _super);
    function Table(props) {
        var _this = _super.call(this, props) || this;
        _this.setRowSelection = function (selectedRows) {
            var _a = _this.props, rowKey = _a.rowKey, data = _a.data;
            if (!rowKey) {
                return;
            }
            if (selectedRows.length === 0) {
                _this.setState({ allChecked: false, checkedItems: [] });
                return;
            }
            var selectedRowsIds = map_1.default(selectedRows, rowKey);
            var checkedItems = [];
            var allChecked = false;
            if (data) {
                checkedItems = filter_1.default(_this.props.data, function (x) {
                    return includes_1.default(selectedRowsIds, x[rowKey]);
                });
                allChecked = data.length > 0 && checkedItems.length === data.length;
            }
            _this.setState({ allChecked: allChecked, checkedItems: checkedItems });
        };
        _this.toggleAllChecked = function () {
            var data = _this.props.data;
            var allChecked = !_this.state.allChecked;
            var checkedItems = allChecked
                ? (data || []).slice().filter(function (r) { return !_this.isDisabled(r); })
                : [];
            if (_this.props.onCheck) {
                _this.props.onCheck(checkedItems);
            }
            _this.setState({ allChecked: allChecked, checkedItems: checkedItems });
        };
        _this.toggleChecked = function (e) {
            var _a;
            var rowKey = _this.props.rowKey;
            var key = e.currentTarget.dataset.key;
            if (!rowKey || !key) {
                return false;
            }
            var item = _this.getElementFromKey(key);
            if (!item) {
                return;
            }
            var identifier = item[rowKey];
            var isChecked = !_this.isChecked(item);
            var checkedItems = isChecked
                ? _this.state.checkedItems.concat(item)
                : reject_1.default(_this.state.checkedItems, (_a = {},
                    _a[rowKey] = identifier,
                    _a));
            if (_this.props.onCheck) {
                _this.props.onCheck(checkedItems);
            }
            _this.setState({
                allChecked: _this.isEachRowChecked(checkedItems),
                checkedItems: checkedItems,
            });
        };
        _this.toggleSort = function (e) {
            var field = e.currentTarget.dataset.field;
            var sort = _this.state.sort;
            if (!field) {
                return;
            }
            var nextSort = {
                field: field,
                reverse: false,
            };
            if (sort.field === field) {
                nextSort = { field: sort.field, reverse: !sort.reverse };
            }
            _this.setState({ sort: nextSort });
            if (_this.props.onSort) {
                _this.props.onSort(nextSort);
            }
        };
        _this.onRowClick = function (e) {
            if (!_this.props.onRowClick) {
                return;
            }
            if (!_this.props.rowKey) {
                return console.warn('onRowClick requires that you provide a `rowKey` property');
            }
            var key = e.currentTarget.dataset.key;
            if (!key) {
                return console.warn('onRowClick called on an element without a key set');
            }
            var row = _this.getElementFromKey(key);
            if (row) {
                _this.props.onRowClick(row, e);
            }
        };
        _this.setPage = function (change) {
            if (_this.props.onPageChange) {
                _this.props.onPageChange(change);
            }
            _this.setState({ page: change });
        };
        _this.resetPager = function () {
            _this.setPage(0);
        };
        _this.incrementPage = function () {
            _this.setPage(_this.state.page + 1);
        };
        _this.decrementPage = function () {
            _this.setPage(_this.state.page - 1);
        };
        if (props.onCheck && !props.rowKey) {
            throw new Error('A `rowKey` property must be provided if using `onCheck` with a Table component');
        }
        var sortState = props.sort || {
            reverse: false,
            field: null,
        };
        _this.state = {
            allChecked: false,
            sort: sortState,
            checkedItems: [],
            page: 0,
        };
        return _this;
    }
    Table.prototype.componentDidUpdate = function (prevProps) {
        var _a, _b, _c;
        if (this.props.sort && !isEqual_1.default(prevProps.sort, this.props.sort)) {
            this.setState({
                sort: this.props.sort,
            });
        }
        var totalItems = (_b = (_a = this.props.data) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0;
        var itemsPerPage = (_c = this.props.itemsPerPage) !== null && _c !== void 0 ? _c : 50;
        if (this.state.page !== 0 && totalItems <= this.state.page * itemsPerPage) {
            this.resetPager();
        }
    };
    Table.prototype.isChecked = function (item) {
        var _a;
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return false;
        }
        var identifier = item[rowKey];
        return some_1.default(this.state.checkedItems, (_a = {}, _a[rowKey] = identifier, _a));
    };
    Table.prototype.isHighlighted = function (item) {
        if (!this.props.highlightedRows ||
            this.props.highlightedRows.length === 0) {
            return false;
        }
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return false;
        }
        var identifier = item[rowKey];
        return includes_1.default(this.props.highlightedRows, identifier);
    };
    Table.prototype.isDisabled = function (item) {
        if (!this.props.disabledRows || this.props.disabledRows.length === 0) {
            return false;
        }
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return false;
        }
        var identifier = item[rowKey];
        return includes_1.default(this.props.disabledRows, identifier);
    };
    Table.prototype.isEachRowChecked = function (checkedItems) {
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return false;
        }
        var selectedKeys = map_1.default(checkedItems, rowKey);
        return every_1.default(this.props.data, function (x) { return includes_1.default(selectedKeys, x[rowKey]); });
    };
    Table.prototype.sortData = function (data) {
        var sort = this.state.sort;
        if (!sort || sort.field === null) {
            return data;
        }
        var column = find_1.default(this.props.columns, { field: sort.field });
        if (!column) {
            return data;
        }
        var collection;
        if (isFunction_1.default(column.sortable)) {
            collection = data.slice().sort(column.sortable);
        }
        else {
            collection = sortBy_1.default(data.slice(), function (item) {
                var sortableValue = item[sort.field];
                return isPlainObject_1.default(sortableValue)
                    ? sortableValue.value
                    : sortableValue;
            });
        }
        if (sort.reverse) {
            reverse_1.default(collection);
        }
        return collection;
    };
    Table.prototype.getElementFromKey = function (key) {
        var _a = this.props, data = _a.data, rowKey = _a.rowKey;
        if (!data) {
            return;
        }
        if (rowKey) {
            return find_1.default(data, function (element) { return "" + element[rowKey] === key; });
        }
        return data[Number(key)];
    };
    Table.prototype.render = function () {
        var _this = this;
        var _a = this.props, columns = _a.columns, data = _a.data, usePager = _a.usePager, itemsPerPage = _a.itemsPerPage, pagerPosition = _a.pagerPosition, rowAnchorAttributes = _a.rowAnchorAttributes, rowKey = _a.rowKey, onCheck = _a.onCheck, onRowClick = _a.onRowClick, getRowHref = _a.getRowHref, getRowClass = _a.getRowClass, props = __rest(_a, ["columns", "data", "usePager", "itemsPerPage", "pagerPosition", "rowAnchorAttributes", "rowKey", "onCheck", "onRowClick", "getRowHref", "getRowClass"]);
        var _b = this.state, page = _b.page, sort = _b.sort;
        var items = data || [];
        var totalItems = items.length;
        var _itemsPerpage = itemsPerPage || 50;
        var _pagerPosition = pagerPosition || 'top';
        var lowerBound = usePager ? page * _itemsPerpage : 0;
        var upperBound = usePager
            ? Math.min((page + 1) * _itemsPerpage, totalItems)
            : totalItems;
        var sortedData = this.sortData(items).slice(lowerBound, upperBound);
        var shouldShowPaper = !!usePager && totalItems > 0;
        return (React.createElement(React.Fragment, null,
            shouldShowPaper &&
                (_pagerPosition === 'top' || _pagerPosition === 'both') && (React.createElement(Pager_1.default, { totalItems: totalItems, itemsPerPage: _itemsPerpage, page: page, nextPage: this.incrementPage, prevPage: this.decrementPage, mb: 2 })),
            React.createElement(BaseTableWrapper, null,
                React.createElement(BaseTable, __assign({}, props, { hasRowClick: !!onRowClick, hasGetRowRef: !!getRowHref, hasCheckbox: !!onCheck }),
                    React.createElement("div", { "data-display": "table-head" },
                        React.createElement("div", { "data-display": "table-row" },
                            onCheck && (React.createElement(TableRow_1.CheckboxWrapper, { "data-display": "table-cell" },
                                React.createElement(Checkbox_1.default, { checked: this.state.allChecked, onChange: this.toggleAllChecked }))),
                            map_1.default(columns, function (item) {
                                if (item.sortable) {
                                    return (React.createElement("div", { "data-display": "table-cell", key: item.field },
                                        React.createElement(HeaderButton, { "data-field": item.field, plain: true, primary: sort.field === item.field, onClick: _this.toggleSort },
                                            item.label || item.field,
                                            "\u00A0",
                                            React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faSort_1.faSort, color: sort.field === item.field
                                                    ? theme_1.default.colors.info.main
                                                    : '' }))));
                                }
                                return (React.createElement("div", { "data-display": "table-cell", key: item.field }, item.label || item.field));
                            }))),
                    React.createElement("div", { "data-display": "table-body" },
                        this.props.tbodyPrefix,
                        map_1.default(sortedData, function (row, i) {
                            var isChecked = onCheck ? _this.isChecked(row) : false;
                            var isHighlighted = _this.isHighlighted(row);
                            var isDisabled = _this.isDisabled(row);
                            var key = rowKey ? row[rowKey] : i;
                            var href = !!getRowHref ? getRowHref(row) : undefined;
                            var classNamesList = isFunction_1.default(getRowClass)
                                ? getRowClass(row)
                                : [];
                            var className = isArray_1.default(classNamesList)
                                ? classNamesList.join(' ')
                                : '';
                            return (React.createElement(TableRow_1.TableRow, { isChecked: isChecked, isHighlighted: isHighlighted, isDisabled: isDisabled, key: key, keyAttribute: key, href: href, data: row, showCheck: !!onCheck, columns: columns, attributes: rowAnchorAttributes, checkboxAttributes: _this.props.rowCheckboxAttributes, toggleChecked: _this.toggleChecked, onRowClick: _this.onRowClick, className: className }));
                        })))),
            shouldShowPaper &&
                (_pagerPosition === 'bottom' || _pagerPosition === 'both') && (React.createElement(Pager_1.default, { totalItems: totalItems, itemsPerPage: _itemsPerpage, page: page, nextPage: this.incrementPage, prevPage: this.decrementPage, mt: 2 }))));
    };
    return Table;
}(React.Component));
exports.default = Table;
var templateObject_1, templateObject_2, templateObject_3;
