"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_simplemde_editor_1 = __importDefault(require("react-simplemde-editor"));
var styled_components_1 = __importDefault(require("styled-components"));
var defaultStyle_1 = __importDefault(require("./defaultStyle"));
var StyledEditor = styled_components_1.default(react_simplemde_editor_1.default)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t", ";\n\t/* Make the editor adjust to the container's height*/\n\theight: 100%;\n\n\t.CodeMirror,\n\t.CodeMirror-scroll {\n\t\t/* The minHeight is inline hard-coded in the library to 300px*/\n\t\tmin-height: 150px !important;\n\t\theight: 100%;\n\t}\n"], ["\n\t", ";\n\t/* Make the editor adjust to the container's height*/\n\theight: 100%;\n\n\t.CodeMirror,\n\t.CodeMirror-scroll {\n\t\t/* The minHeight is inline hard-coded in the library to 300px*/\n\t\tmin-height: 150px !important;\n\t\theight: 100%;\n\t}\n"])), defaultStyle_1.default);
exports.MarkdownEditor = function (_a) {
    var value = _a.value, onChange = _a.onChange;
    return (react_1.default.createElement(StyledEditor, { value: value, onChange: onChange, options: {
            spellChecker: false,
            status: false,
            showIcons: ['code', 'table'],
        } }));
};
var templateObject_1;
