/// <reference types="lodash/common/common" />
/// <reference types="lodash/common/array" />
/// <reference types="lodash/common/collection" />
/// <reference types="lodash/common/date" />
/// <reference types="lodash/common/function" />
/// <reference types="lodash/common/lang" />
/// <reference types="lodash/common/math" />
/// <reference types="lodash/common/number" />
/// <reference types="lodash/common/object" />
/// <reference types="lodash/common/seq" />
/// <reference types="lodash/common/string" />
/// <reference types="lodash/common/util" />
import { Theme } from '../common-types';
export declare const getLegibleTextColor: ((bg: string, contrast?: any) => string) & import("lodash").MemoizedFunction;
export declare const generateColorFromString: ((text: string) => string) & import("lodash").MemoizedFunction;
export declare const isLight: (color?: string | undefined) => boolean;
export declare const opaque: (color: string, opacity: number) => string;
export declare const lighten: (color: string) => string;
export declare const darken: (color: string) => string;
export declare const getColoringType: (props: {
    [key: string]: any;
    theme: Theme;
}) => string | undefined;
export declare const getColor: (props: {
    [key: string]: any;
    theme: Theme;
}, key: string, shade: "main" | "dark" | "light") => string | undefined;
