"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var faMinus_1 = require("@fortawesome/free-solid-svg-icons/faMinus");
var faPlus_1 = require("@fortawesome/free-solid-svg-icons/faPlus");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var grommet_1 = require("grommet");
var React = __importStar(require("react"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var utils_1 = require("../../utils");
var Box_1 = require("../Box");
var Flex_1 = require("../Flex");
var Txt_1 = __importDefault(require("../Txt"));
var Accordion = function (props) {
    var _a = React.useState([]), openPanels = _a[0], setOpenPanels = _a[1];
    var items = props.items;
    return (React.createElement(grommet_1.Accordion, { activeIndex: openPanels, onActive: function (opens) { return setOpenPanels(opens); } }, items.map(function (item, index) { return (React.createElement(grommet_1.AccordionPanel, { header: React.createElement(Flex_1.Flex, { alignItems: "center", justifyContent: "space-between" },
            React.createElement(Flex_1.Flex, { px: 16 },
                React.createElement(Txt_1.default, { my: 24, fontSize: 16, bold: true }, item.label)),
            React.createElement(Flex_1.Flex, { alignItems: "center", justifyContent: "flex-end", pr: 16 },
                React.createElement(react_fontawesome_1.FontAwesomeIcon, { color: utils_1.getColor(__assign(__assign({}, props), { gray: true }), 'color', 'main'), icon: openPanels.includes(index) ? faMinus_1.faMinus : faPlus_1.faPlus }))) },
        React.createElement(Box_1.Box, { px: 16, mt: 10, mb: 24 }, item.panel))); })));
};
exports.default = asRendition_1.default(Accordion, []);
