"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var grommet_1 = require("grommet");
var merge_1 = __importDefault(require("lodash/merge"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var theme_1 = __importDefault(require("../../theme"));
var utils_1 = require("../../utils");
var BreakpointProvider_1 = require("./BreakpointProvider");
var Base = styled_components_1.default(grommet_1.Grommet)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-family: ", ";\n\tfont-size: ", ";\n\tcolor: ", ";\n\n\th1,\n\th2,\n\th3,\n\th4,\n\th5,\n\th6,\n\tbutton {\n\t\tfont-family: ", ";\n\t}\n"], ["\n\tfont-family: ", ";\n\tfont-size: ", ";\n\tcolor: ", ";\n\n\th1,\n\th2,\n\th3,\n\th4,\n\th5,\n\th6,\n\tbutton {\n\t\tfont-family: ", ";\n\t}\n"])), function (props) { return props.theme.font; }, function (props) { return utils_1.px(props.theme.fontSizes[1]); }, function (props) { return utils_1.px(props.theme.colors.text.main); }, function (props) { return props.theme.titleFont; });
var Provider = function (_a) {
    var theme = _a.theme, props = __rest(_a, ["theme"]);
    var providerTheme = merge_1.default(theme_1.default, theme);
    return (React.createElement(BreakpointProvider_1.BreakpointProvider, { breakpoints: providerTheme.breakpoints },
        React.createElement(Base, __assign({ theme: providerTheme }, props))));
};
exports.default = Provider;
var templateObject_1;
