"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var animations_1 = require("../../animations");
var asRendition_1 = __importDefault(require("../../asRendition"));
var utils_1 = require("../../utils");
var Flex_1 = require("../Flex");
var Txt_1 = __importDefault(require("../Txt"));
var CircleLoader = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tbackground: transparent !important;\n\twidth: ", ";\n\theight: ", ";\n\tborder: ", " solid;\n\tcolor: ", ";\n\tborder-radius: 100%;\n\tborder-bottom-color: transparent;\n\tdisplay: inline-block;\n\tanimation: ", " 1s 0s infinite linear;\n\tanimation-fill-mode: both;\n"], ["\n\tbackground: transparent !important;\n\twidth: ", ";\n\theight: ", ";\n\tborder: ", " solid;\n\tcolor: ", ";\n\tborder-radius: 100%;\n\tborder-bottom-color: transparent;\n\tdisplay: inline-block;\n\tanimation: ", " 1s 0s infinite linear;\n\tanimation-fill-mode: both;\n"])), function (props) { return utils_1.px(props.emphasized ? 40 : 20); }, function (props) { return utils_1.px(props.emphasized ? 40 : 20); }, function (props) { return utils_1.px(props.emphasized ? 6 : 4); }, function (props) { return props.theme.colors.tertiary.main; }, animations_1.rotate360);
var Container = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: relative;\n"], ["\n\tposition: relative;\n"])));
var SpinnerContainer = styled_components_1.default(Flex_1.Flex)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tposition: absolute;\n\ttop: 0;\n\tleft: 0;\n\tbottom: 0;\n\tright: 0;\n\tz-index: 4;\n"], ["\n\tposition: absolute;\n\ttop: 0;\n\tleft: 0;\n\tbottom: 0;\n\tright: 0;\n\tz-index: 4;\n"])));
var ChildrenContainer = styled_components_1.default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\topacity: ", ";\n\ttransition: opacity 250ms;\n\tz-index: 3;\n"], ["\n\topacity: ", ";\n\ttransition: opacity 250ms;\n\tz-index: 3;\n"])), function (props) { return (props.show ? 0.4 : 1); });
var SpinnerBase = function (_a) {
    var label = _a.label, emphasized = _a.emphasized, otherProps = __rest(_a, ["label", "emphasized"]);
    return (React.createElement(Flex_1.Flex, __assign({ flexDirection: emphasized ? 'column' : 'row', justifyContent: "center", alignItems: "center", width: "fit-content" }, otherProps),
        React.createElement(CircleLoader, { emphasized: emphasized }),
        label && (React.createElement(Txt_1.default, { color: "text.light", ml: emphasized ? 0 : 2, mt: emphasized ? 2 : 0 }, label))));
};
var Spinner = function (_a) {
    var _b = _a.show, show = _b === void 0 ? true : _b, emphasized = _a.emphasized, label = _a.label, children = _a.children, otherProps = __rest(_a, ["show", "emphasized", "label", "children"]);
    if (!children) {
        if (!show) {
            return null;
        }
        return (React.createElement(SpinnerBase, __assign({ label: label, emphasized: emphasized }, otherProps)));
    }
    return (React.createElement(Container, __assign({}, otherProps),
        show && (React.createElement(SpinnerContainer, { justifyContent: "center", alignItems: "center" },
            React.createElement(SpinnerBase, { label: label, emphasized: emphasized }))),
        React.createElement(ChildrenContainer, { show: show }, children)));
};
exports.default = asRendition_1.default(Spinner);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
