"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var get_1 = __importDefault(require("lodash/get"));
var styled_components_1 = require("styled-components");
exports.normal = function (props) {
    return get_1.default(props.theme, 'weights.0');
};
exports.bold = function (props) {
    return get_1.default(props.theme, 'weights.1');
};
exports.px = function (n) { return (typeof n === 'number' ? n + 'px' : n); };
exports.monospace = function (props) {
    return props.monospace
        ? styled_components_1.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t\t\tfont-family: ", ";\n\t\t  "], ["\n\t\t\t\tfont-family: ", ";\n\t\t  "])), props.theme.monospace) : null;
};
exports.emphasized = function (props) {
    return styled_components_1.css(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t\theight: ", ";\n\t"], ["\n\t\theight: ",
        ";\n\t"])), exports.px(props.emphasized ? props.theme.space[5] : props.theme.space[4]));
};
var templateObject_1, templateObject_2;
