import { __assign, __makeTemplateObject, __rest } from "tslib";
import { Grommet } from 'grommet';
import merge from 'lodash/merge';
import * as React from 'react';
import styled from 'styled-components';
import defaultTheme from '../../theme';
import { px } from '../../utils';
import { BreakpointProvider } from './BreakpointProvider';
var Base = styled(Grommet)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-family: ", ";\n\tfont-size: ", ";\n\tcolor: ", ";\n\n\th1,\n\th2,\n\th3,\n\th4,\n\th5,\n\th6,\n\tbutton {\n\t\tfont-family: ", ";\n\t}\n"], ["\n\tfont-family: ", ";\n\tfont-size: ", ";\n\tcolor: ", ";\n\n\th1,\n\th2,\n\th3,\n\th4,\n\th5,\n\th6,\n\tbutton {\n\t\tfont-family: ", ";\n\t}\n"])), function (props) { return props.theme.font; }, function (props) { return px(props.theme.fontSizes[1]); }, function (props) { return px(props.theme.colors.text.main); }, function (props) { return props.theme.titleFont; });
var Provider = function (_a) {
    var theme = _a.theme, props = __rest(_a, ["theme"]);
    var providerTheme = merge(defaultTheme, theme);
    return (React.createElement(BreakpointProvider, { breakpoints: providerTheme.breakpoints },
        React.createElement(Base, __assign({ theme: providerTheme }, props))));
};
export default Provider;
var templateObject_1;
